%global pkg slime
%global pkgname Slime
%global alphatag 20120525cvs

Name:            emacs-%{pkg}
Version:         3.0
Release:         0.7.%{alphatag}%{?dist}
Summary:         The superior lisp interaction mode for emacs        

Group:           Applications/Editors
#Public domain: Mentioned in README file
#LLGPL: Mentioned in swank-ccl.lisp
#GPLv2+: slime.el,slime-autoloads.el
#GPLv3+: Many files in contrib are GPLv3+
License:         Public Domain and GPLv3+ and GPLv2+ and LLGPL
URL:             http://common-lisp.net/project/slime/
Source0:         http://common-lisp.net/project/slime/snapshots/slime-current.tgz


BuildRequires:   emacs texinfo common-lisp-controller
Requires:        emacs(bin) >= %{_emacs_version} common-lisp-controller

Requires(post):  info common-lisp-controller
Requires(preun): info common-lisp-controller

BuildArch:      noarch
Patch1:         slime_fix_changelog_and_backend.patch
Patch2:         swank_changelog_plus_location.patch

%description
SLIME is a Emacs mode for common Lisp development.

%package el
Summary:        Elisp source files for %{name}
Group:          Applications/Editors
Requires:       %{name} = %{version}-%{release}

%description el
This package contains the Elisp source files for %{name}. You do not need
to install this package to use %{name}.

%prep
%setup -q -n %{pkg}-2012-05-25
%patch1 -p1
%patch2 -p1

iconv --from=ISO-8859-1 --to=UTF-8 ChangeLog > ChangeLog.conv && mv ChangeLog.conv ChangeLog

%build
%{_emacs_bytecompile} *.el
cd doc/
make slime.info

%install
rm -rf %{buildroot}

install -pm 755 -d %{buildroot}%{_emacs_sitestartdir}
install -pm 644 *.el  %{buildroot}%{_emacs_sitestartdir}

install -pm 755 -d %{buildroot}%{_infodir}
install -pm 644 doc/%{pkg}.info %{buildroot}%{_infodir}/

install -pm 755 -d %{buildroot}%{_emacs_sitelispdir}/%{pkg}
install -pm 755 -d %{buildroot}%{_emacs_sitelispdir}/%{pkg}/contrib
install -pm 644 *.el* %{buildroot}%{_emacs_sitelispdir}/%{pkg}/


install -pm 755 -d %{buildroot}%{_datadir}/common-lisp/source/slime
install -pm 755 -d %{buildroot}%{_datadir}/common-lisp/source/slime/contrib
install -pm 644 *.lisp %{buildroot}%{_datadir}/common-lisp/source/slime
install -pm 644 contrib/*.lisp %{buildroot}%{_datadir}/common-lisp/source/slime/contrib
install -pm 644 contrib/*.el %{buildroot}%{_datadir}/common-lisp/source/slime/contrib
install -pm 644 contrib/README %{buildroot}%{_datadir}/common-lisp/source/slime/contrib
install -pm 644 contrib/ChangeLog %{buildroot}%{_datadir}/common-lisp/source/slime/contrib
install -pm 644 *.asd %{buildroot}%{_datadir}/common-lisp/source/slime

mv contrib/README contrib/contrib-README
mv contrib/ChangeLog contrib/contrib-ChangeLog

%clean
rm -rf %{buildroot}

%post
/sbin/install-info %{_infodir}/%{pkg}.info %{_infodir}/dir || :
/usr/sbin/register-common-lisp-source swank

%preun
if [ "$1" = 0 ]; then
 /sbin/install-info --delete %{_infodir}/%{pkg}.info %{_infodir}/dir || :
fi
/usr/sbin/unregister-common-lisp-source swank 

%files
%defattr(-,root,root,-)
%doc ChangeLog NEWS PROBLEMS README doc/slime-small.pdf doc/slime-refcard.pdf contrib/contrib-README contrib/contrib-ChangeLog

%dir %{_emacs_sitestartdir}
%{_emacs_sitestartdir}/*.el

%dir %{_emacs_sitelispdir}/%{pkg}
%dir %{_emacs_sitelispdir}/%{pkg}/contrib
%{_emacs_sitelispdir}/%{pkg}/*.elc

%dir %{_datadir}/common-lisp/source/slime
%dir %{_datadir}/common-lisp/source/slime/contrib
%{_datadir}/common-lisp/source/slime/*.lisp
%{_datadir}/common-lisp/source/slime/contrib/*.lisp
%{_datadir}/common-lisp/source/slime/contrib/*.el
%{_datadir}/common-lisp/source/slime/contrib/README
%{_datadir}/common-lisp/source/slime/contrib/ChangeLog
%{_datadir}/common-lisp/source/slime/*.asd
%{_infodir}/%{pkg}.info.gz

%files el
%defattr(-,root,root,-)
%doc HACKING
%{_emacs_sitelispdir}/%{pkg}/*.el

%changelog
* Wed Jul 25 2012 Lakshmi Narasimhan T V <lakshminaras2002@gmail.com> - 3.0-0.7.20120525cvs
- Hardcode location of slime-backend
- Renamed patches
- Removed known_implementations.patch. Otherwise inferior-lisp-program variable is not used by slime.

* Mon Jul 23 2012 Lakshmi Narasimhan T V <lakshminaras2002@gmail.com> - 3.0-0.6.20120525cvs
- All .el files go into -el package except for those under contrib. They go into common-lisp/source/slime
- Copy readme and changelog into contrib folder. Gives an idea of how to load the definitions into emacs.
- Rename readme and changelog under contrib and put them into doc folder as well.

* Mon Jul 23 2012 Lakshmi Narasimhan T V <lakshminaras2002@gmail.com> - 3.0-0.5.20120525cvs
- Apply patches to fix slime load error.
- Copy contrib directory in both base and el packages.

* Wed Jul 18 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.0-0.4.20101113cvs
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Fri Jan 13 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.0-0.3.20101113cvs
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Tue Feb 08 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.0-0.2.20101113cvs
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Sun Nov 14 2010 Arun SAG <sagarun at gmail dot com> - 3.0-0.1.20101113cvs
- Fixed the version information
- Fixed the license information
- Removed the buildroot tag as it is obsolete

* Sat Sep 11 2010 Arun SAG <sagarun at gmail dot com> - 1.2-1
- Initial release
